searchNodes=[{"doc":"EctoCrypto is a collection ecto types for encrypting and hashing data.","ref":"EctoCrypto.html","title":"EctoCrypto","type":"module"},{"doc":"Ecto Type for encrypting and decrypting binaries (including strings). Defines an Ecto Type which can be cast as a binary string which encrypts the string using AES-256 GCM before it is inserted into the database. When the value is retrieved from the database, it is decrypted before it is dumped to the Ecto schema struct.","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html","title":"EctoCrypto.EctoTypes.EncryptedBinary","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#cast/1","title":"EctoCrypto.EctoTypes.EncryptedBinary.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#dump/1","title":"EctoCrypto.EctoTypes.EncryptedBinary.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#embed_as/1","title":"EctoCrypto.EctoTypes.EncryptedBinary.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#equal?/2","title":"EctoCrypto.EctoTypes.EncryptedBinary.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#load/1","title":"EctoCrypto.EctoTypes.EncryptedBinary.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"EctoCrypto.EctoTypes.EncryptedBinary.html#type/0","title":"EctoCrypto.EctoTypes.EncryptedBinary.type/0","type":"function"},{"doc":"Utility module for encrypting and decrypting with AES-256 GCM.","ref":"EctoCrypto.Utility.Aes.html","title":"EctoCrypto.Utility.Aes","type":"module"},{"doc":"Decrypts ciphertext encrypted with AES-256 GCM into plaintext. Uses they key stored in application configuration.","ref":"EctoCrypto.Utility.Aes.html#decrypt/1","title":"EctoCrypto.Utility.Aes.decrypt/1","type":"function"},{"doc":"Encrypts plaintext to ciphertext using AES-256 GCM. Uses the key stored in application configuration.","ref":"EctoCrypto.Utility.Aes.html#encrypt/1","title":"EctoCrypto.Utility.Aes.encrypt/1","type":"function"},{"doc":"Generates a key suitable for encrypting/decrypting with AES-256 GCM.","ref":"EctoCrypto.Utility.Aes.html#generate_key/0","title":"EctoCrypto.Utility.Aes.generate_key/0","type":"function"},{"doc":"Getting Started","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"EctoCrypto provides Ecto types and utilities for saving data in encrypted or hashed formats. The goal is to provide easy to use, sane, and secure cryptographic functionality that can be dropped directly into Ecto schemas.","ref":"getting-started.html#description","title":"Getting Started - Description","type":"extras"},{"doc":"The package can be installed by adding ecto_crypto to your list of dependencies in mix.exs : def deps do [ { :ecto_crypto , &quot;~&gt; 0.1.0&quot; } ] end","ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"The following assumes that you have a database table generated with the following migration: defmodule Repo.Migrations.CreateTestSchema do use Ecto.Migration def change do create table ( :test_schema ) do add :encrypted_string , :binary end end end To create an ecto schema with a field that automatically encrypted at the field level upon being inserted to the database, use the EctoCrypto.EctoTypes.EncryptedBinary Ecto type in the schema. defmodule TestSchema do use Ecto.Schema import Ecto.Changeset schema &quot;test_schema&quot; do field ( :encrypted_string , EctoCrypto.EctoTypes.EncryptedBinary ) end @fields ~w(encrypted_string)a def changeset ( attrs ) do changeset ( % TestSchema { } , attrs ) end def changeset ( % TestSchema { } = schema , attrs ) do cast ( schema , attrs , @fields ) end end When interacting with this schema in elixir, the field should behave like a regular string or binary field. At the database level, the field will be encrypted.","ref":"getting-started.html#how-does-it-work","title":"Getting Started - How does it work?","type":"extras"}]